import greenfoot.*;

/**
 * Write a description of class Mouse here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mouse extends Actor
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private int cheeseEaten;
    
    /**
     * Create a Mouse and initialize its two images.
     */
    public Mouse()
    {
        image1 = new GreenfootImage("mouse21.png");
        image2 = new GreenfootImage("mouse22.png");
        setImage(image1);
        cheeseEaten = 0;
    }
    
    /** 
     * Act - do whatever the Mouse wants to do. This method is called whenever
     *  the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkKeyPress();
        lookForCheese();
        switchImage();
    }
    
      /**
     * Alternate the crab's image between image1 and image2 when hitting the left and right side
     */
    public void switchImage()
    {
        if (getX() == 0)
        {
            setImage(image1);
        }
        
        if (getX() == 799)
        {
            setImage(image2);
        }
    }
    
     /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
        }
        
        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }
        
        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation(getX()+4, getY());
            setImage(image1);
        }
        
        if (Greenfoot.isKeyDown("left")) 
        {
            setLocation(getX()-4, getY());
            setImage(image2);
        }
    }
    
    /**
     * Check whether we have stumbled upon a Cheese.
     * If we have, eat it. If not, do nothing. If we have
     * eaten ten cheeses, we win.
     */
    public void lookForCheese()
    {
        if ( isTouching(Cheese.class) ) 
        {
            removeTouching(Cheese.class);
            
            cheeseEaten = cheeseEaten + 1;
            
            Kitchen kitchen = (Kitchen)getWorld();
            kitchen.addScore(1);
            
            if (cheeseEaten == 10) 
            {
                Greenfoot.stop();
                kitchen.showWinMessage();
            }
        }
    } 
}
